<?php

/*********************************************************************

 新着スケジュール表示プラグイン (2014/07/05)

  32877|http://32877.xii.jp

*********************************************************************/

/* メイン処理 */
function freo_display_schedule_recently()
{
	global $freo;

	if ($freo->config['plugin']['schedule_recently']['default_limit'] == 0) {
		return;
	}

	//検索条件設定
	$category_id = false;
		if ($freo->config['plugin']['schedule_recently']['category_id']) {
			$category_id = true;
		}

	if ($category_id == true){
		$condition = ' WHERE id IS NOT NULL AND category_id =:category_id';
	} else {
		$condition = ' WHERE id IS NOT NULL OR category_id =:category_id';
	}

	//スケジュール取得
	$stmt = $freo->pdo->prepare('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_schedules ' . $condition . ' ORDER BY datetime DESC LIMIT :limit');
	$stmt->bindValue(':limit', intval($freo->config['plugin']['schedule_recently']['default_limit']), PDO::PARAM_INT);
	$stmt->bindvalue(':category_id', $freo->config['plugin']['schedule_recently']['category_id']);
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}

	$plugin_schedules = array();
	while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
		$plugin_schedules[$data['id']] = $data;
	}

	//スケジュールID取得
	$plugin_schedule_keys = array_keys($plugin_schedules);

	//スケジュールタグ取得
	$plugin_schedule_tags = array();
	foreach ($plugin_schedule_keys as $plugin_schedule) {
		if (!$plugin_schedules[$plugin_schedule]['tag']) {
			continue;
		}

		$plugin_schedule_tags[$plugin_schedule] = explode(',', $plugin_schedules[$plugin_schedule]['tag']);
	}

	//ファイル取得
	$plugin_schedule_files = array();
	foreach ($plugin_schedule_keys as $plugin_schedule) {
		$file_dir = FREO_FILE_DIR . 'plugins/schedule_files/' . $plugin_schedule . '/';

		if (file_exists($file_dir)) {
			if ($dir = scandir($file_dir)) {
				foreach ($dir as $data) {
					if (is_file($file_dir . $data) and preg_match("/(\w+)\.\w+$/", $data, $matches)) {
						$plugin_schedule_files[$plugin_schedule][$matches[1]] = $data;
					}
				}
			} else {
				freo_error('ファイル保存ディレクトリを開けません。');
			}
		}
	}

	//データ割当
	$freo->smarty->assign(array(
		'plugin_schedule_recentries'          => $plugin_schedules,
		'plugin_schedule_recently_tags'       => $plugin_schedule_tags,
		'plugin_schedule_recently_files'      => $plugin_schedule_files
	));

	return;
}

?>
